	#include "lbc.h"	/*SH_co* libluajit-5.1.a -lm -ldl 	*/
	#include "hcut.h"
	#include "msgp.h"
	#include "laptime.h"
	#define loop(a)		for(int lpcnt=1;lpcnt<=a;lpcnt++)
	#define qu(...)		Qsub(__VA_ARGS__)
	#define Qsub(...)	#__VA_ARGS__
HCUT_ADD(t_new) {
	lbc_t* obj = lbc_new();
	dbg(obj->emsg);
	eq(obj);
	lbc_free(obj);
}
HCUT_ADD(t_reqbc) {
	lbc_t* obj = lbc_new();
#include "al.h"
#include "cl.h"
	int rc = lbc_reqbcM(obj, al, cl);
	eq(rc==0, "exit1 if fail");
	lbc_free(obj);
}
HCUT_ADD(t_reqstr) {
	lbc_t* obj = lbc_new();
	const char* al = 
		#include "als.h"
		;
	const char* cl = 
		#include "cls.h"
		;
	int rc = lbc_reqstrM(obj, al, cl);
	eq(rc==0, "exit1 if fail");
	lbc_free(obj);
}
HCUT_ADD(t_runbc) {
	const char* al = 
		#include "als.h"
		;
	const char* cl = 
		#include "cls.h"
		;
	lbc_t* obj = lbc_new();
	int rc = lbc_reqstrM(obj, al, cl);
	eq(rc==0, "exit if err");

	#include "bl.h"
	int n = lbc_runbcM(obj,  argc, argv, bl);
	eq(n>=0, "cnt of rtn args");
	dbg(n, obj->emsg);
	lbc_free(obj);
}
HCUT_ADD(t_runstr) {
	const char* al = 
		#include "als.h"
		;
	const char* cl = 
		#include "cls.h"
		;
	lbc_t* obj = lbc_new();
	int rc = lbc_reqstrM(obj, al, cl);
	eq(rc==0, "exit if err");
	
	const char* s = "return require('cl').cf()";
	int n = lbc_runstrM(obj, argc, argv, s);
	eq(n>=0, "cnt of rtn args");
	dbg(n, obj->emsg);
	lbc_free(obj);
}
HCUT_ADD(t_val) {
	lbc_t* obj = lbc_new();
#include "al.h"
	lbc_reqbcM(obj, al);
#include "bl.h"
	int n = lbc_runbcM(obj, argc, argv, bl);
//;dbg(n, obj->emsg);
	lbc_rt val = lbc_tbval(obj, 0, 1);
;dbg(val.tp, val.i, val.d);
	n = lbc_tbvalsv(-1, obj, 0, 1);
;dbg(n);
	val = lbc_tbval(obj, -1);
;dbg(val.tp, val.i, val.d);
	//	lbc_cleansv(obj);
	lbc_delsv(obj, -1);
	val = lbc_tbval(obj, -1);
;dbg(val.tp, val.i, val.d);
	val = lbc_tbval(obj, n);
;dbg(n, val.tp, val.i, val.d, val.s, val.sz);
	puts("change:");
	val = lbc_tbval(obj, 0, 3, "unko");
;dbg(n, val.tp, val.i, val.d, val.s, val.sz);
	const char* p = "unko";
	val = lbc_tbval(obj, 0, 3, &p);
;dbg(n, val.tp, val.i, val.d, val.s, val.sz);
	n = lbc_directf(obj, "return 11,20,30");
	val = lbc_tbval(obj, 0, 3);
	eq_i(val.tp, 'n');
	eq_i(val.i, 30);
;dbg(n, val.i);

	n = lbc_pdirectf(obj, "return 11,20,30");
	val = lbc_tbval(obj, 0, 1);
;dbg(n, val.tp);
	eq_p(val.s, NULL);
	
	lbc_free(obj);
}
//extern void* lua_gettop();
HCUT_ADD(t_directf) {
	lbc_t* obj = lbc_new();
#include "al.h"
	lbc_reqbcM(obj, al);
#include "bl.h"
	lbc_runbcM(obj, argc, argv, bl);
dbg(lua_gettop(obj->L));
	int n = lbc_directf(obj, "return 10,20,30");
	eq_i(n, 3);
	lbc_pairs(k, v, obj, 0) {
		dbg(k.i, v.i);
	}
	lbc_ipairs(i, v, obj, 0) {
		dbg(i, v.i);
	}
dbg(lua_gettop(obj->L));
laptime(0);
#define LP 1*1000
	loop(LP){ lbc_directf(obj, "local arr={}; arr[10]=20");}
laptime("direct: " qu(LP) );
	//direct access
	const char* cmd = 
		" ffi = require('ffi')"
		" local tb = {}; for i=1,1000 do tb[#tb+1]=i end"
		" local box= ffi.new('int[?]', #tb, tb )"
		" local adrs= tonumber(ffi.cast('intptr_t',ffi.cast('void *', box)))"
		" return adrs, box, tb"		//holds datasrc to protect from gc.
	;
	lbc_directf(obj, "%s", cmd);
	lbc_rt res = lbc_tbval(obj, 0, 1);	//adrs
	int* arr = (int*)(intptr_t)res.d;	// arr >> adrs >> box
	dbg( arr[0], arr[1] );		//>>1,2
	
	const char* s = "a\0bc";
	const char* fmt = 
	" local cdata = ffi.new('intptr_t', %p)"
	" cdata = ffi.cast('char*', cdata)"
	// if use intptr_t, use c99 header inttypes.h macro 'PRId/o/x/uPTR'
	//" local cdata = ffi.new('char*'," PRIdPTR ")"	//printf(fmt, (intptr_t)s);
	" local str = ffi.string(cdata, %d)"
	" print(str)"
	" return str..'xyz'"
	;
	lbc_directf(obj, fmt, s, 4);	// sz==4
	res = lbc_tbval(obj, 0, 1);		//adrs
	dbg( res.tp, res.s, res.s+2, res.sz);	// 's', a(\0bcxyz), bcxyz, 7
	lbc_free(obj);
}
HCUT_ADD(t_pairs) {
	lbc_t* obj = lbc_new();
#include "al.h"
#include "bl.h"
	lbc_reqbcM(obj, al);
	lbc_runbcM(obj, argc, argv, bl);
	//
	lbc_pairs(k, v, obj, 0) {
		int rc = lbc_valsv(obj, -1);
		dbg(rc, k.tp, k.s, k.i, v.tp, v.s, v.i, v.d, v.sz);
	}
	lbc_pairs(i, v, obj, 0) {
		dbg(i, v.tp);
		puts(v.s?v.s:"no" );
	}
	lbc_free(obj);
}
HCUT_ADD(t_bm1) {
	lbc_t* obj = lbc_new();
	#include "al.h"
	#include "bl.h"
	lbc_reqbcM(obj, al);
	lbc_runbcM(obj, argc, argv, bl);
	//
#undef LP
#define LP	1000*1000
	laptime(0);
	loop(LP){ lbc_rt res = lbc_tbval(obj, 0, 1);res=res;}
	laptime("tbval() getloop: " qu(LP));

	laptime(0);
	loop(LP){ int n = lbc_tbvalsv(1, obj, 0, 1);n=n;}
	laptime("tbval() setloop: " qu(LP));
	
	lbc_free(obj);
//lj	154.00ms	:	local num=100*1000*1000
//real	2556.991 ms	: ./lbc.ts.c 115: t_bm1_sub(): msg:tbval() getloop: 1000*1000
//real	2943.116 ms	: ./lbc.ts.c 119: t_bm1_sub(): msg:tbval() setloop: 1000*1000
}
#include <stdio.h>
#include <stdlib.h>
#include <search.h>

#define LPnum 1000*1000
HCUT_ADD(t_bm2) {
	ENTRY e;
	ENTRY *ep=NULL;
	eq_p(ep, NULL);
	hcreate(30);
	; laptime(0);
	loop(LPnum) {
		e.key = "key";
		e.data = (void *) 1;
		ep = hsearch(e, ENTER);
	}
	; laptime("c99setloop: " qu(LPnum));
	; laptime(0);
	loop(LPnum) {
		e.key = "key";
		ep = hsearch(e, FIND);
//		printf("%d\n", (int)ep->data );
		//printf("%9.9s -> %9.9s:%d\n", e.key, ep ? ep->key : "NULL", ep ? (int)(ep->data) : 0);
	}
	; laptime("c99getloop: " qu(LPnum));
	hdestroy();
//real	46.685 ms	: ./lbc.ts.c 141: t_bm2_sub(): msg:c99setloop: 1000*1000
//real	44.315 ms	: ./lbc.ts.c 149: t_bm2_sub(): msg:c99getloop: 1000*1000
}
HCUT_ADD(t_bm3) {
	int sz=1000;
	int arr[sz];
	for(int i=0;i<sz;i++){arr[i]=i;}
	laptime(0);
	loop(LPnum) { arr[LPnum%sz]=10; }
	laptime("arr, setloop: " qu(LPnum));
//
	laptime(0);
	int b=0;
	eq(b==0);
	loop(LPnum) { b=arr[LPnum%sz]; }
	laptime("arr, getloop: " qu(LPnum));
//real	21.068 ms	: ./lbc.ts.c 159: t_bm3_sub(): msg:arr, setloop: 1000*1000
//real	16.977 ms	: ./lbc.ts.c 164: t_bm3_sub(): msg:arr, getloop: 1000*1000
}
HCUT_ADD(t_bm4) {
	lhh_t* obj = lhh_new();
	laptime(0);
	loop(LPnum) { lhh_set(obj, lpcnt, lpcnt); }
	laptime("lhh, setloop: " qu(LPnum));
//
	lhh_rt res;
	laptime(0);
	loop(LPnum) { res = lhh_get(obj, lpcnt); }
	laptime("lhh, getloop: " qu(LPnum));
	res=res;
//real	197.392 ms	: ./lbc.ts.c 172: t_bm4_sub(): msg:lhh, setloop: 1000*1000
//real	192.476 ms	: ./lbc.ts.c 177: t_bm4_sub(): msg:arr, getloop: 1000*1000
}
HCUT_ADD(t_lhh) {
	lhh_t* obj = lhh_new();
	lhh_set(obj, "key1", "val");
	lhh_set(obj, "key2", 11);
	const char* p = "123\0xyz";
	lhh_set(obj, "key3", &p, 7);
	lhh_set(obj, 3, 10);
	lhh_set(obj, 4, "unko");
	lhh_set(obj, 5, &p, 6);
;dbg(obj->cnt);	//6
	lhh_unset(obj, 3);
;dbg(obj->cnt);	//5
	lhh_setd(obj, (double)9.2, 10.1);
	lhh_rt res = lhh_get(obj, 4);
;dbg(res.s, res.tp, res.sz);
	res = lhh_getd(obj, 9.2);
;dbg(res.s, res.tp, res.sz, res.d, res.i);
;dbg();
	lbc_pairs(k,v,obj){
		dbg(k.i, k.d, k.s, k.tp, v.i, v.d, v.s, v.tp);
		//lhh_get(obj, 3);
		lhh_unset(obj, 5);
	}
	lhh_free(obj);
}
HCUT_RUN("stderr", 1,
 t_new, t_reqbc, t_reqstr, t_runbc, t_runstr, t_val, t_directf, t_pairs, t_bm1, t_bm2, t_bm3, t_bm4, t_lhh, NULL)
